/*********************************************************************
*                SEGGER Microcontroller GmbH & Co. KG                *
*                        The Embedded Experts                        *
**********************************************************************
*                                                                    *
*       (c) 2003 - 2015  SEGGER Microcontroller GmbH & Co. KG        *
*                                                                    *
*       www.segger.com     Support: support@segger.com               *
*                                                                    *
**********************************************************************
----------------------------------------------------------------------
File        : Resource.h
Purpose     : Resources
---------------------------END-OF-HEADER------------------------------
*/
#ifndef RESOURCE_H
#define RESOURCE_H

#include "Main.h"

/*********************************************************************
*
*       Externals
*
**********************************************************************
*/
//
// Fonts
//
extern GUI_CONST_STORAGE GUI_FONT     GUI_FontCommodore64Angled8;
extern GUI_CONST_STORAGE GUI_FONT     GUI_FontCommodore64Angled9;
extern GUI_CONST_STORAGE GUI_FONT     GUI_FontCommodore64Angled10;
extern GUI_CONST_STORAGE GUI_FONT     GUI_FontCommodore64Angled12;
extern GUI_CONST_STORAGE GUI_FONT     GUI_FontCommodore64Angled14;
extern GUI_CONST_STORAGE GUI_FONT     GUI_FontCommodore64Angled18;
extern GUI_CONST_STORAGE GUI_FONT     GUI_FontCommodore64Angled20;
extern GUI_CONST_STORAGE GUI_FONT     GUI_FontCommodore64Angled24;
extern GUI_CONST_STORAGE GUI_FONT     GUI_FontCommodore64Angled32;
extern GUI_CONST_STORAGE GUI_FONT     GUI_FontCommodore64Angled40;
extern GUI_CONST_STORAGE GUI_FONT     GUI_FontOctinSportsRg40;
extern GUI_CONST_STORAGE GUI_FONT     GUI_FontSFSportsNight48;
extern GUI_CONST_STORAGE GUI_FONT     GUI_Fontlazer8448;
extern GUI_CONST_STORAGE GUI_FONT     GUI_FontFont_24;
extern GUI_CONST_STORAGE GUI_FONT     GUI_FontFont_48;
//
// Main Menu Background
//
extern GUI_CONST_STORAGE GUI_BITMAP   bmArchery_200x113;
#if (BRANDING == RENESAS_BRANDING)
extern GUI_CONST_STORAGE GUI_BITMAP   bmRunning_200x113;
extern GUI_CONST_STORAGE GUI_BITMAP   bmLifting_200x113;
extern GUI_CONST_STORAGE GUI_BITMAP   bmCycling_200x113;
#elif (BRANDING == SEGGER_BRANDING)
extern GUI_CONST_STORAGE GUI_BITMAP   bmRunning_SEGGER_200x113;
extern GUI_CONST_STORAGE GUI_BITMAP   bmLifting_SEGGER_200x113;
extern GUI_CONST_STORAGE GUI_BITMAP   bmCycling_SEGGER_200x113;
#endif
//
// Buttons
//
extern GUI_CONST_STORAGE GUI_BITMAP   bmHelpButton_36x36;
extern GUI_CONST_STORAGE GUI_BITMAP   bmExitButton_36x36;
extern GUI_CONST_STORAGE GUI_BITMAP   bmClickLayer_204x117;
extern GUI_CONST_STORAGE GUI_BITMAP   bmPointingArrow_21x30;
extern GUI_CONST_STORAGE GUI_BITMAP   bmPointingArrow_15x22;
//
// Archery
//
extern GUI_CONST_STORAGE GUI_BITMAP   bmNextButton_30x30;
extern GUI_CONST_STORAGE GUI_BITMAP   bmArrow_16x37;
extern GUI_CONST_STORAGE GUI_BITMAP   bmQuiver_37x110;
extern GUI_CONST_STORAGE GUI_BITMAP   bmAirplane_145x27;
extern GUI_CONST_STORAGE GUI_BITMAP   bmTouchArea_170x120;
extern GUI_CONST_STORAGE GUI_BITMAP   bmFuji_bare_480x136;
//
// Shot Arrows
//
extern GUI_CONST_STORAGE GUI_BITMAP   bmShot_Arrow_0;
extern GUI_CONST_STORAGE GUI_BITMAP   bmShot_Arrow_1;
extern GUI_CONST_STORAGE GUI_BITMAP   bmShot_Arrow_2;
extern GUI_CONST_STORAGE GUI_BITMAP   bmShot_Arrow_3;
extern GUI_CONST_STORAGE GUI_BITMAP   bmShot_Arrow_4;
extern GUI_CONST_STORAGE GUI_BITMAP   bmShot_Arrow_5;
extern GUI_CONST_STORAGE GUI_BITMAP   bmShot_Arrow_6;
//
// Running
//
extern GUI_CONST_STORAGE GUI_BITMAP * apbmRunner1_Small[6];
extern GUI_CONST_STORAGE GUI_BITMAP   bmStand_14x77;
extern GUI_CONST_STORAGE GUI_BITMAP   bmAudience_new_144x57;
extern GUI_CONST_STORAGE GUI_BITMAP   bmShoe1_100x100;
extern GUI_CONST_STORAGE GUI_BITMAP   bmShoe2_100x100;
extern GUI_CONST_STORAGE GUI_BITMAP   bmEnergy_18x19;
//
// Meter marks
//
extern GUI_CONST_STORAGE GUI_BITMAP   bm100m_95x91;
extern GUI_CONST_STORAGE GUI_BITMAP   bm200m_95x91;
extern GUI_CONST_STORAGE GUI_BITMAP   bm300m_95x91;
extern GUI_CONST_STORAGE GUI_BITMAP   bmstartend_95x91;
//
// Logos
//
#if (BRANDING == RENESAS_BRANDING)
extern GUI_CONST_STORAGE GUI_BITMAP   bmrenesas_logo_196x32;
extern GUI_CONST_STORAGE GUI_BITMAP   bmRenesas_small;
#elif (BRANDING == SEGGER_BRANDING)
extern GUI_CONST_STORAGE GUI_BITMAP   bmSeggerLogo_50x25;
extern GUI_CONST_STORAGE GUI_BITMAP   bmSeggerLogo_90x45;
#endif
//
// Weightlifting
//
extern GUI_CONST_STORAGE GUI_BITMAP * apbmLifter_146x148[13];
extern GUI_CONST_STORAGE GUI_BITMAP   bmFloor_480x65;
//
// Buttons
//
extern GUI_CONST_STORAGE GUI_BITMAP   bmActionButton_Unpressed_130x80;
extern GUI_CONST_STORAGE GUI_BITMAP   bmActionButton_Pressed_130x80;
//
// Weights
//
extern GUI_CONST_STORAGE GUI_BITMAP   bmWeight_small_6x50;
extern GUI_CONST_STORAGE GUI_BITMAP   bmWeight_med_6x50;
extern GUI_CONST_STORAGE GUI_BITMAP   bmWeight_big_6x50;
//
// Cycling
//
extern GUI_CONST_STORAGE GUI_BITMAP   bmBarrier_224x56;
extern GUI_CONST_STORAGE GUI_BITMAP   bmCrowd_130x90;
extern GUI_CONST_STORAGE GUI_BITMAP   bmBuildings_358x132;
extern GUI_CONST_STORAGE GUI_BITMAP   bmStartFinish_Left_26x160;
extern GUI_CONST_STORAGE GUI_BITMAP   bmStartFinish_Right_125x264;
extern GUI_CONST_STORAGE GUI_BITMAP   bmKnob_150x150;
extern GUI_CONST_STORAGE GUI_BITMAP * apbmBicycleRider_15F_134x122[15];
//
// Keyboard layout
//
extern const KEYDEF_KEYBOARD KEYBOARD_ENG_Custom;

/*********************************************************************
*
*       Defines
*
**********************************************************************
*/
//
// Bitmap Macros
//
#define BM_RENESAS                bmrenesas_logo_196x32
#define BM_POINT_ARROW            bmPointingArrow_15x22

//
// Fonts Macros
//
#define FONT_C64_8                &GUI_FontCommodore64Angled8
#define FONT_C64_9                &GUI_FontCommodore64Angled9
#define FONT_C64_10               &GUI_FontCommodore64Angled10
#define FONT_C64_12               &GUI_FontCommodore64Angled12
#define FONT_C64_14               &GUI_FontCommodore64Angled14
#define FONT_C64_18               &GUI_FontCommodore64Angled18
#define FONT_C64_20               &GUI_FontCommodore64Angled20
#define FONT_C64_24               &GUI_FontCommodore64Angled24
#define FONT_C64_32               &GUI_FontCommodore64Angled32
#define FONT_C64_40               &GUI_FontCommodore64Angled40
                                  
#define FONT_BOXY_24              &GUI_FontFont_24
#define FONT_BOXY_48              &GUI_FontFont_48
#define FONT_SPORTS_48            &GUI_FontSFSportsNight48
#define FONT_OCTIN_48             &GUI_FontOctinSportsRg40
#define FONT_LAZER_48             &GUI_Fontlazer8448

//
// Custom messages
//
#define MSG_ANIMATE               (WM_USER + 0x00)

//
// Branding
//
#define COLOR_RENESAS_BLUE        GUI_MAKE_COLOR(0x009B3F2D)
#define COLOR_SEGGER_BLUE         GUI_MAKE_COLOR(0x00A85C00)
#if (BRANDING == SEGGER_BRANDING)
#define AIRPLANE_STR_XOFF         6
#define AIRPLANE_STR_YOFF         11
#define AIRPLANE_STR_COLOR        COLOR_SEGGER_BLUE
#define AIRPLANE_STR              "SEGGER"
#elif (BRANDING == RENESAS_BRANDING)
#define AIRPLANE_STR_XOFF         4
#define AIRPLANE_STR_YOFF         11
#define AIRPLANE_STR_COLOR        COLOR_RENESAS_BLUE
#define AIRPLANE_STR              "RENESAS"
#endif

//
// Colors
//
#define COLOR_METER_MARK          GUI_MAKE_COLOR(0x001DACD0)

#define COLOR_GRAY_A9             GUI_MAKE_COLOR(0x00A9A9A9)

#define COLOR_GREY_PRIMARY        GUI_MAKE_COLOR(0x00A9A9A9)
#define COLOR_GREY_SECONDARY      GUI_MAKE_COLOR(0x00808080)
#define COLOR_ORANGE_PRIMARY      GUI_MAKE_COLOR(0x004763FF)
#define COLOR_ORANGE_SECONDARY    GUI_MAKE_COLOR(0x000045FF)
#define COLOR_RED_EXIT            GUI_MAKE_COLOR(0x004D4DFF)

#define COLOR_STATWIN_1           GUI_MAKE_COLOR(0x00DFD9CF)
#define COLOR_STATWIN_2           GUI_MAKE_COLOR(0x00F0EBE2)

#define COLOR_SKY_1               GUI_MAKE_COLOR(0x00FFBA00)
#define COLOR_SKY_2               GUI_MAKE_COLOR(0x00FAE4B4)

#define COLOR_MENU_BK_1           GUI_MAKE_COLOR(0x00FBE9C2)
#define COLOR_MENU_BK_2           GUI_MAKE_COLOR(0x00FDC4A1)

#define COLOR_EXHAUST             GUI_MAKE_COLOR(0x00FF8000)

// Target colors
#define COLOR_TARGET_BLACK        GUI_MAKE_COLOR(0x00231F20)
#define COLOR_TARGET_RED          GUI_MAKE_COLOR(0x003840F1)
#define COLOR_TARGET_BLUE         GUI_MAKE_COLOR(0x00E5A401)
#define COLOR_TARGET_YELLOW       GUI_MAKE_COLOR(0x0000F0FF)
#define COLOR_AIM_RED             GUI_MAKE_COLOR(0x002222B2)

#define COLOR_HIGHLIGHTED_RED     GUI_MAKE_COLOR(0x000000CC)

//
// GUI IDs
//

// Main Menu
#define ID_BUTTON_MENU_PLAY       (GUI_ID_USER + 0x02)
#define ID_BUTTON_MENU_HIGHSCORE  (GUI_ID_USER + 0x03)
#define ID_BUTTON_MENU_SETTINGS   (GUI_ID_USER + 0x04)
#define ID_BUTTON_MENU_HELP       (GUI_ID_USER + 0x05)
#define ID_BUTTON_MENU_EXIT       (GUI_ID_USER + 0x06)
#define ID_BUTTON_MENU_PLAYGAME0  (GUI_ID_USER + 0x07)
#define ID_BUTTON_MENU_PLAYGAME1  (GUI_ID_USER + 0x08)
#define ID_BUTTON_MENU_PLAYGAME2  (GUI_ID_USER + 0x09)
#define ID_BUTTON_MENU_PLAYGAME3  (GUI_ID_USER + 0x0A)

#define ID_BUTTON_MENU_DEMO1      (GUI_ID_USER + 0x30)
#define ID_BUTTON_MENU_DEMO2      (GUI_ID_USER + 0x31)
#define ID_BUTTON_MENU_DEMO3      (GUI_ID_USER + 0x32)
#define ID_BUTTON_MENU_DEMO4      (GUI_ID_USER + 0x33)

#define ID_WINDOW_MENU            (GUI_ID_USER + 0x00)
#define ID_WINDOW_MENU_SELECT     (GUI_ID_USER + 0x10)
#define ID_WINDOW_MENU_CIRCLE     (GUI_ID_USER + 0x20)

#define ID_TEXT_MENU_HEADER       (GUI_ID_USER + 0x01)
#define ID_TEXT_MENU_DEMO1        (GUI_ID_USER + 0x11)
#define ID_TEXT_MENU_DEMO2        (GUI_ID_USER + 0x12)
#define ID_TEXT_MENU_DEMO3        (GUI_ID_USER + 0x13)
#define ID_TEXT_MENU_DEMO4        (GUI_ID_USER + 0x14)

// Settings
#define ID_BUTTON_SETTINGS_OK     (GUI_ID_USER + 0x40)
#define ID_EDIT_SETTINGS           GUI_ID_EDIT0
#define ID_TEXT_SETTINGS_NAME     (GUI_ID_USER + 0x16)

// Highscore
#define ID_TEXT_HIGHSCORE_HEADER  (GUI_ID_USER + 0x40)

// General
#define ID_BUTTON_MENU            (GUI_ID_USER + 0x07) // Back button

// Runner
#define ID_BUTTON_RUN_LEFT        GUI_ID_BUTTON0
#define ID_BUTTON_RUN_RIGHT       GUI_ID_BUTTON1

// Weightlifting
#define ID_BUTTON_WEIGHT_LESS     (GUI_ID_USER + 0x50)
#define ID_BUTTON_WEIGHT_MORE     (GUI_ID_USER + 0x51)
#define ID_BUTTON_WEIGHT_ACTION   (GUI_ID_USER + 0x52)
#define ID_TEXT_WEIGHT_KG         (GUI_ID_USER + 0x53)
#define ID_TEXT_WEIGHT_ACTION     (GUI_ID_USER + 0x54)
#define ID_TEXT_WEIGHT_RECORD     (GUI_ID_USER + 0x55)
#define ID_TEXT_WEIGHT_TRIES_T    (GUI_ID_USER + 0x56)
#define ID_TEXT_WEIGHT_TRIES      (GUI_ID_USER + 0x57)


#endif /* RESOURCE_H */

/*************************** End of file ****************************/